
MODULE vector_module
!
!  Purpose:
!    To define the derived data type for 2D vectors,  
!    plus addition and subtraction operations.
!
!  Record of revisions:
!       Date       Programmer          Description of change
!       ====       ==========          =====================
!     12/04/15    S. J. Chapman        Original code
!
IMPLICIT NONE

! Declare type vector
TYPE :: vector
   REAL :: x                         ! X value
   REAL :: y                         ! Y value
END TYPE vector

! Add procedures
CONTAINS

   TYPE (vector) FUNCTION vector_add ( v1, v2 )
   !
   !  Purpose:
   !    To add two vectors.
   !
   !  Record of revisions:
   !      Date       Programmer          Description of change
   !      ====       ==========          =====================
   !    12/04/15    S. J. Chapman        Original code
   !
   IMPLICIT NONE
   
   ! Data dictionary: declare calling parameter types & definitions
   TYPE (vector), INTENT(IN) :: v1           ! First vector
   TYPE (vector), INTENT(IN) :: v2           ! Second vector

   ! Add the vectors
   vector_add%x = v1%x + v2%x
   vector_add%y = v1%y + v2%y

   END FUNCTION vector_add

   TYPE (vector) FUNCTION vector_sub ( v1, v2 )
   !
   !  Purpose:
   !    To subtract two vectors.
   !
   !  Record of revisions:
   !      Date       Programmer          Description of change
   !      ====       ==========          =====================
   !    12/14/05    S. J. Chapman        Original code
   !
   IMPLICIT NONE
   
   ! Data dictionary: declare calling parameter types & definitions
   TYPE (vector), INTENT(IN) :: v1           ! First point 
   TYPE (vector), INTENT(IN) :: v2           ! Second point 

   ! Add the points
   vector_sub%x = v1%x - v2%x
   vector_sub%y = v1%y - v2%y

   END FUNCTION vector_sub

END MODULE vector_module
